//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46D84F900148.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46D84F900148.cm

//## begin module%46D84F900148.cp preserve=no
//## end module%46D84F900148.cp

//## Module: FITSChain%46D84F900148; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/FITSChain.h

#ifndef FITSCHAIN_H
#define FITSCHAIN_H 1

//## begin module%46D84F900148.additionalIncludes preserve=no
//## end module%46D84F900148.additionalIncludes

//## begin module%46D84F900148.includes preserve=yes
//## end module%46D84F900148.includes

// ChainIO
#include <XSFit/MCMC/ChainIO.h>

namespace CCfits {
    class FITS;
} // namespace CCfits

class Chain;

//## begin module%46D84F900148.declarations preserve=no
//## end module%46D84F900148.declarations

//## begin module%46D84F900148.additionalDeclarations preserve=yes
namespace CCfits {
   class Table;
}
//## end module%46D84F900148.additionalDeclarations


//## begin FITSChain%46DD8511002A.preface preserve=yes
//## end FITSChain%46DD8511002A.preface

//## Class: FITSChain%46DD8511002A
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%46DDB77E00A3;Chain { -> F}

class FITSChain : public ChainIO  //## Inherits: <unnamed>%46DD852400C2
{
  //## begin FITSChain%46DD8511002A.initialDeclarations preserve=yes
  //## end FITSChain%46DD8511002A.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: FITSChain%46DDB6A80339
      FITSChain (string fileName = string(""));

    //## Destructor (generated)
      virtual ~FITSChain();


    //## Other Operations (specified)
      //## Operation: doOpenForReadPoints%46DD8BCA0282
      virtual void doOpenForReadPoints () const;

      //## Operation: doCloseFile%46DD8BD1010B
      virtual void doCloseFile () const;

      //## Operation: doOpenForWrite%46DF24DD00B3
      virtual void doOpenForWrite ();

      //## Operation: doReadPoint%46DD8BD700B2
      virtual void doReadPoint (std::vector<Real>& chainVals) const;

      //## Operation: doReadPointFromLine%46DD8BDF0088
      virtual void doReadPointFromLine (size_t lineNum, RealArray& parVals) const;

      //## Operation: getFormatName%46DDC05F033A
      virtual const string& getFormatName () const;

      //## Operation: readFileInfo%46E06B4602ED
      virtual void readFileInfo ();

      //## Operation: createFile%46E157A600DE
      virtual void createFile ();

      //## Operation: writePoint%46E157C00124
      virtual void writePoint ();

      //## Operation: writeFileInfo%46E157B1011A
      virtual void writeFileInfo ();

      //## Operation: appendFile%46E1583300A5
      virtual void appendFile (RealArray& startingVals);

      //## Operation: adjustTemperInfo%46E1583D0088
      virtual void adjustTemperInfo ();

      //## Operation: checkTemperField%46E84191015D
      virtual bool checkTemperField (const Real temperature) const;

      //## Operation: setParent%46DDB42903D8
      virtual void setParent (Chain* chain);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: FORMATNAME%46DDBC0F012D
      static const string& FORMATNAME ();

    // Additional Public Declarations
      //## begin FITSChain%46DD8511002A.public preserve=yes
      //## end FITSChain%46DD8511002A.public

  protected:
    // Additional Protected Declarations
      //## begin FITSChain%46DD8511002A.protected preserve=yes
      //## end FITSChain%46DD8511002A.protected

  private:
    //## Constructors (generated)
      FITSChain(const FITSChain &right);

    //## Assignment Operation (generated)
      FITSChain & operator=(const FITSChain &right);


    //## Other Operations (specified)
      //## Operation: intToKeyIndex%46E1B513011D
      static string intToKeyIndex (int iEntry);

      //## Operation: readTemperInfo%46E56E8F0315
      void readTemperInfo (CCfits::Table* table);

      //## Operation: readParamInfo%46E58D8603D2
      void readParamInfo (CCfits::Table* table);

      //## Operation: writeHistory%46EEEBA10157
      void writeHistory (bool isAppend) const;

    // Additional Private Declarations
      //## begin FITSChain%46DD8511002A.private preserve=yes
      //## end FITSChain%46DD8511002A.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin FITSChain::FORMATNAME%46DDBC0F012D.attr preserve=no  public: static const string {U} string("fits")
      static const string s_FORMATNAME;
      //## end FITSChain::FORMATNAME%46DDBC0F012D.attr

      //## Attribute: EXTNAME%46E17014013B
      //## begin FITSChain::EXTNAME%46E17014013B.attr preserve=no  private: static string {UC} string("CHAIN")
      static const string s_EXTNAME;
      //## end FITSChain::EXTNAME%46E17014013B.attr

      //## Attribute: TEMPERKEY%46E170C70387
      //## begin FITSChain::TEMPERKEY%46E170C70387.attr preserve=no  private: static string {UC} string("TEMPR")
      static const string s_TEMPERKEY;
      //## end FITSChain::TEMPERKEY%46E170C70387.attr

      //## Attribute: ROWKEY%46E1712902C7
      //## begin FITSChain::ROWKEY%46E1712902C7.attr preserve=no  private: static string {UC} string("STROW")
      static const string s_ROWKEY;
      //## end FITSChain::ROWKEY%46E1712902C7.attr

      //## Attribute: FLOATTYPE%46E1718403C1
      //## begin FITSChain::FLOATTYPE%46E1718403C1.attr preserve=no  private: static string {UC} string("D")
      static const string s_FLOATTYPE;
      //## end FITSChain::FLOATTYPE%46E1718403C1.attr

      //## Attribute: STATCOL%46E1720B00A6
      //## begin FITSChain::STATCOL%46E1720B00A6.attr preserve=no  private: static string {UC} string("FIT_STATISTIC")
      static const string s_STATCOL;
      //## end FITSChain::STATCOL%46E1720B00A6.attr

      //## Attribute: TEMPERDIGITS%46E188C40304
      //## begin FITSChain::TEMPERDIGITS%46E188C40304.attr preserve=no  private: static size_t {UC} 3
      static const size_t s_TEMPERDIGITS;
      //## end FITSChain::TEMPERDIGITS%46E188C40304.attr

      //## Attribute: COLNAMEDELIM%46EE8DB6021B
      //## begin FITSChain::COLNAMEDELIM%46EE8DB6021B.attr preserve=no  private: static string {UC} string("__")
      static const string s_COLNAMEDELIM;
      //## end FITSChain::COLNAMEDELIM%46EE8DB6021B.attr

      //## Attribute: chain%46DDB45202D9
      //	Pointer to the Chain object which owns this object.
      //	This obviously must be a non-owning pointer or else it
      //	will be a circular dependency.
      //## begin FITSChain::chain%46DDB45202D9.attr preserve=no  private: Chain* {U} 
      Chain* m_chain;
      //## end FITSChain::chain%46DDB45202D9.attr

      //## Attribute: iRow%46E7F4080077
      //## begin FITSChain::iRow%46E7F4080077.attr preserve=no  private: long {UM} 
      mutable long m_iRow;
      //## end FITSChain::iRow%46E7F4080077.attr

      //## Attribute: doFileFlush%474C6CCC0035
      //## begin FITSChain::doFileFlush%474C6CCC0035.attr preserve=no  private: bool {U} 
      bool m_doFileFlush;
      //## end FITSChain::doFileFlush%474C6CCC0035.attr

    // Data Members for Associations

      //## Association: XSFit::MCMC::<unnamed>%46E04C4D0085
      //## Role: FITSChain::fits%46E04C4F009E
      //	Opaque pointer to FITS object
      //## begin FITSChain::fits%46E04C4F009E.role preserve=no  private: CCfits::FITS { -> 1RFHgNM}
      mutable CCfits::FITS* m_fits;
      //## end FITSChain::fits%46E04C4F009E.role

    // Additional Implementation Declarations
      //## begin FITSChain%46DD8511002A.implementation preserve=yes
      //## end FITSChain%46DD8511002A.implementation

};

//## begin FITSChain%46DD8511002A.postscript preserve=yes
//## end FITSChain%46DD8511002A.postscript

// Class FITSChain 

//## Get and Set Operations for Class Attributes (inline)

inline const string& FITSChain::FORMATNAME ()
{
  //## begin FITSChain::FORMATNAME%46DDBC0F012D.get preserve=no
  return s_FORMATNAME;
  //## end FITSChain::FORMATNAME%46DDBC0F012D.get
}

//## begin module%46D84F900148.epilog preserve=yes
//## end module%46D84F900148.epilog


#endif
